com.smartgwt.client.tools

## Class GridEditProxy

- java.lang.Object
- - com.smartgwt.client.core.BaseClass
  - - com.smartgwt.client.tools.EditProxy
    - - com.smartgwt.client.tools.CanvasEditProxy
      - - com.smartgwt.client.tools.LayoutEditProxy
        - - com.smartgwt.client.tools.GridEditProxy

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers

      public class GridEditProxy
      extends LayoutEditProxy

  `EditProxy` that handles `ListGrid` and `TreeGrid` components when editMode is enabled.
  See Also:
    `DevTools overview and related methods`

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.BaseClass

      `config, configOnly, factoryCreated, factoryProperties, id, scClassName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GridEditProxy()`
    `GridEditProxy(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.Boolean` | `getCanAddFormulaFields()` Can new formula fields be created from header context menu? Overrides `ListGrid.canAddFormulaFields` when in edit mode.
    `java.lang.Boolean` | `getCanAddSummaryFields()` Can new summary fields be created from header context menu? Overrides `ListGrid.canAddSummaryFields` when in edit mode.
    `java.lang.Boolean` | `getCanEditHilites()` Can highlights be edited from header context menu? Overrides `ListGrid.canEditHilites` when in edit mode.
    `java.lang.Boolean` | `getCanGroupBy()` Can records be grouped from header context menu? Overrides `ListGrid.canGroupBy` when in edit mode.
    `java.lang.Boolean` | `getCanReorderFields()` Indicates whether fields in this listGrid can be reordered by dragging and dropping header fields.
    `java.lang.Boolean` | `getCanResizeFields()` Indicates whether fields in this listGrid can be resized by dragging header fields.
    `java.lang.Boolean` | `getGenerateEditableFormulas()` Controls whether formula fields created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode).
    `java.lang.Boolean` | `getGenerateEditableHilites()` Controls whether highlights created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode).
    `java.lang.Boolean` | `getGenerateEditableSummaries()` Controls whether summary fields created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode).
    `void` | `getInlineEditText()` Returns the text based on the current component state to be edited inline.
    `static GridEditProxy` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.Boolean` | `getSaveFieldFrozenState()` Should changes to which fields are `frozen` be persisted?
    `java.lang.Boolean` | `getSaveFieldOrder()` Should changes to grid field order be persisted?
    `java.lang.Boolean` | `getSaveFieldVisibility()` Should changes to grid field visibility be persisted?
    `java.lang.Boolean` | `getSaveFilterCriteria()` Should changes to filter criteria by end user editing of criteria in the `filter editor` by persisted?
    `java.lang.Boolean` | `getSaveGroupBy()` Should changes to grid grouping (including both grouping and ungrouping the grid) be persisted?
    `java.lang.Boolean` | `getSaveSort()` Should changes to which fields are sorted be persisted?
    `void` | `setCanAddFormulaFields(java.lang.Boolean canAddFormulaFields)` Can new formula fields be created from header context menu? Overrides `ListGrid.canAddFormulaFields` when in edit mode.
    `void` | `setCanAddSummaryFields(java.lang.Boolean canAddSummaryFields)` Can new summary fields be created from header context menu? Overrides `ListGrid.canAddSummaryFields` when in edit mode.
    `void` | `setCanEditHilites(java.lang.Boolean canEditHilites)` Can highlights be edited from header context menu? Overrides `ListGrid.canEditHilites` when in edit mode.
    `void` | `setCanGroupBy(java.lang.Boolean canGroupBy)` Can records be grouped from header context menu? Overrides `ListGrid.canGroupBy` when in edit mode.
    `void` | `setCanReorderFields(java.lang.Boolean canReorderFields)` Indicates whether fields in this listGrid can be reordered by dragging and dropping header fields.
    `void` | `setCanResizeFields(java.lang.Boolean canResizeFields)` Indicates whether fields in this listGrid can be resized by dragging header fields.
    `void` | `setGenerateEditableFormulas(java.lang.Boolean generateEditableFormulas)` Controls whether formula fields created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode).
    `void` | `setGenerateEditableHilites(java.lang.Boolean generateEditableHilites)` Controls whether highlights created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode).
    `void` | `setGenerateEditableSummaries(java.lang.Boolean generateEditableSummaries)` Controls whether summary fields created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode).
    `void` | `setInlineEditText(java.lang.String newValue)` Save the new value into the component's state.
    `void` | `setSaveFieldFrozenState(java.lang.Boolean saveFieldFrozenState)` Should changes to which fields are `frozen` be persisted?
    `void` | `setSaveFieldOrder(java.lang.Boolean saveFieldOrder)` Should changes to grid field order be persisted?
    `void` | `setSaveFieldVisibility(java.lang.Boolean saveFieldVisibility)` Should changes to grid field visibility be persisted?
    `void` | `setSaveFilterCriteria(java.lang.Boolean saveFilterCriteria)` Should changes to filter criteria by end user editing of criteria in the `filter editor` by persisted?
    `void` | `setSaveGroupBy(java.lang.Boolean saveGroupBy)` Should changes to grid grouping (including both grouping and ungrouping the grid) be persisted?
    `void` | `setSaveSort(java.lang.Boolean saveSort)` Should changes to which fields are sorted be persisted?

    - ### Methods inherited from class com.smartgwt.client.tools.EditProxy

      `getAllowNestedDrops, getAutoMaskChildren, getBringToFrontOnSelect, getCanSelect, getCanSelectChildren, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getEditMask, getHoopSelector, getInlineEditEvent, getInlineEditForm, getInlineEditInstructionLabel, getInlineEditInstructions, getInlineEditMultiline, getInlineEditOnDrop, getJsObj, getOrCreateJsObj, getPersistCoordinates, getSelectedAppearance, getSelectedBorder, getSelectedLabelBackgroundColor, getSelectedTintColor, getSelectedTintOpacity, getSupportsInlineEdit, isCreated, setAllowNestedDrops, setAutoMaskChildren, setBringToFrontOnSelect, setCanSelect, setCanSelectChildren, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setInlineEditEvent, setInlineEditInstructions, setInlineEditMultiline, setInlineEditOnDrop, setJavaScriptObject, setPersistCoordinates, setSelectedAppearance, setSelectedBorder, setSelectedLabelBackgroundColor, setSelectedTintColor, setSelectedTintOpacity, setSupportsInlineEdit, showSelectedAppearance, startInlineEditing, startInlineEditing`

    - ### Methods inherited from class com.smartgwt.client.core.BaseClass

      `applyFactoryProperties, asSGWTComponent, createJsObj, destroy, doAddHandler, doInit, error, error, errorIfNotCreated, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getAttributeAsStringArray, getClassName, getConfig, getHandlerCount, getID, getRef, getScClassName, getTestInstance, hasAutoAssignedID, internalSetID, internalSetID, isConfigOnly, isFactoryCreated, onBind, onInit, registerID, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setFactoryCreated, setID, setProperty, setProperty, setProperty, setProperty, setScClassName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GridEditProxy

          public GridEditProxy()

    - #### GridEditProxy

          public GridEditProxy(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static GridEditProxy getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### create

          public com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `LayoutEditProxy`

    - #### setCanAddFormulaFields

          public void setCanAddFormulaFields(java.lang.Boolean canAddFormulaFields)
                                      throws java.lang.IllegalStateException

      Can new formula fields be created from header context menu? Overrides `ListGrid.canAddFormulaFields` when in edit mode.
      Parameters:
        `canAddFormulaFields` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getCanAddFormulaFields

          public java.lang.Boolean getCanAddFormulaFields()

      Can new formula fields be created from header context menu? Overrides `ListGrid.canAddFormulaFields` when in edit mode.
      Returns:
        Boolean

    - #### setCanAddSummaryFields

          public void setCanAddSummaryFields(java.lang.Boolean canAddSummaryFields)
                                      throws java.lang.IllegalStateException

      Can new summary fields be created from header context menu? Overrides `ListGrid.canAddSummaryFields` when in edit mode.
      Parameters:
        `canAddSummaryFields` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getCanAddSummaryFields

          public java.lang.Boolean getCanAddSummaryFields()

      Can new summary fields be created from header context menu? Overrides `ListGrid.canAddSummaryFields` when in edit mode.
      Returns:
        Boolean

    - #### setCanEditHilites

          public void setCanEditHilites(java.lang.Boolean canEditHilites)
                                 throws java.lang.IllegalStateException

      Can highlights be edited from header context menu? Overrides `ListGrid.canEditHilites` when in edit mode.
      Parameters:
        `canEditHilites` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getCanEditHilites

          public java.lang.Boolean getCanEditHilites()

      Can highlights be edited from header context menu? Overrides `ListGrid.canEditHilites` when in edit mode.
      Returns:
        Boolean

    - #### setCanGroupBy

          public void setCanGroupBy(java.lang.Boolean canGroupBy)
                             throws java.lang.IllegalStateException

      Can records be grouped from header context menu? Overrides `ListGrid.canGroupBy` when in edit mode.
      Parameters:
        `canGroupBy` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getCanGroupBy

          public java.lang.Boolean getCanGroupBy()

      Can records be grouped from header context menu? Overrides `ListGrid.canGroupBy` when in edit mode.
      Returns:
        Boolean

    - #### setCanReorderFields

          public void setCanReorderFields(java.lang.Boolean canReorderFields)
                                   throws java.lang.IllegalStateException

      Indicates whether fields in this listGrid can be reordered by dragging and dropping header fields. Overrides `ListGrid.canReorderFields` when in edit mode.
      Parameters:
        `canReorderFields` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getCanReorderFields

          public java.lang.Boolean getCanReorderFields()

      Indicates whether fields in this listGrid can be reordered by dragging and dropping header fields. Overrides `ListGrid.canReorderFields` when in edit mode.
      Returns:
        Boolean

    - #### setCanResizeFields

          public void setCanResizeFields(java.lang.Boolean canResizeFields)
                                  throws java.lang.IllegalStateException

      Indicates whether fields in this listGrid can be resized by dragging header fields. Overrides `ListGrid.canResizeFields` when in edit mode.
      Parameters:
        `canResizeFields` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getCanResizeFields

          public java.lang.Boolean getCanResizeFields()

      Indicates whether fields in this listGrid can be resized by dragging header fields. Overrides `ListGrid.canResizeFields` when in edit mode.
      Returns:
        Boolean

    - #### setGenerateEditableFormulas

          public void setGenerateEditableFormulas(java.lang.Boolean generateEditableFormulas)
                                           throws java.lang.IllegalStateException

      Controls whether formula fields created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode). See `ListGridField.canEditFormula`.
      Parameters:
        `generateEditableFormulas` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getGenerateEditableFormulas

          public java.lang.Boolean getGenerateEditableFormulas()

      Controls whether formula fields created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode). See `ListGridField.canEditFormula`.
      Returns:
        Boolean

    - #### setGenerateEditableHilites

          public void setGenerateEditableHilites(java.lang.Boolean generateEditableHilites)
                                          throws java.lang.IllegalStateException

      Controls whether highlights created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode). See `Hilite.canEdit`.
      Parameters:
        `generateEditableHilites` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getGenerateEditableHilites

          public java.lang.Boolean getGenerateEditableHilites()

      Controls whether highlights created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode). See `Hilite.canEdit`.
      Returns:
        Boolean

    - #### setGenerateEditableSummaries

          public void setGenerateEditableSummaries(java.lang.Boolean generateEditableSummaries)
                                            throws java.lang.IllegalStateException

      Controls whether summary fields created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode). See `ListGridField.canEditSummary`.
      Parameters:
        `generateEditableSummaries` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getGenerateEditableSummaries

          public java.lang.Boolean getGenerateEditableSummaries()

      Controls whether summary fields created while in edit mode are editable by end users at runtime (when the grid is no longer in edit mode). See `ListGridField.canEditSummary`.
      Returns:
        Boolean

    - #### setSaveFieldFrozenState

          public void setSaveFieldFrozenState(java.lang.Boolean saveFieldFrozenState)
                                       throws java.lang.IllegalStateException

      Should changes to which fields are `frozen` be persisted?

      Note that changes are saved directly into the ListGridFields not via fieldState or viewState settings. EditNodes will also be introduced for fields as needed if they do not already exist.

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Parameters:
        `saveFieldFrozenState` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getSaveFieldFrozenState

          public java.lang.Boolean getSaveFieldFrozenState()

      Should changes to which fields are `frozen` be persisted?

      Note that changes are saved directly into the ListGridFields not via fieldState or viewState settings. EditNodes will also be introduced for fields as needed if they do not already exist.

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Returns:
        Boolean

    - #### setSaveFieldOrder

          public void setSaveFieldOrder(java.lang.Boolean saveFieldOrder)
                                 throws java.lang.IllegalStateException

      Should changes to grid field order be persisted?

      Note that changes are saved directly into the ListGridFields not via fieldState or viewState settings. EditNodes will also be introduced for fields as needed if they do not already exist.

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Parameters:
        `saveFieldOrder` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getSaveFieldOrder

          public java.lang.Boolean getSaveFieldOrder()

      Should changes to grid field order be persisted?

      Note that changes are saved directly into the ListGridFields not via fieldState or viewState settings. EditNodes will also be introduced for fields as needed if they do not already exist.

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Returns:
        Boolean

    - #### setSaveFieldVisibility

          public void setSaveFieldVisibility(java.lang.Boolean saveFieldVisibility)
                                      throws java.lang.IllegalStateException

      Should changes to grid field visibility be persisted?

      Note that changes are saved directly into the ListGridFields not via fieldState or viewState settings. EditNodes will also be introduced for fields as needed if they do not already exist.

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Parameters:
        `saveFieldVisibility` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getSaveFieldVisibility

          public java.lang.Boolean getSaveFieldVisibility()

      Should changes to grid field visibility be persisted?

      Note that changes are saved directly into the ListGridFields not via fieldState or viewState settings. EditNodes will also be introduced for fields as needed if they do not already exist.

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Returns:
        Boolean

    - #### setSaveFilterCriteria

          public void setSaveFilterCriteria(java.lang.Boolean saveFilterCriteria)
                                     throws java.lang.IllegalStateException

      Should changes to filter criteria by end user editing of criteria in the `filter editor` by persisted?

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Parameters:
        `saveFilterCriteria` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getSaveFilterCriteria

          public java.lang.Boolean getSaveFilterCriteria()

      Should changes to filter criteria by end user editing of criteria in the `filter editor` by persisted?

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Returns:
        Boolean

    - #### setSaveGroupBy

          public void setSaveGroupBy(java.lang.Boolean saveGroupBy)
                              throws java.lang.IllegalStateException

      Should changes to grid grouping (including both grouping and ungrouping the grid) be persisted?

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Parameters:
        `saveGroupBy` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getSaveGroupBy

          public java.lang.Boolean getSaveGroupBy()

      Should changes to grid grouping (including both grouping and ungrouping the grid) be persisted?

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Returns:
        Boolean

    - #### setSaveSort

          public void setSaveSort(java.lang.Boolean saveSort)
                           throws java.lang.IllegalStateException

      Should changes to which fields are sorted be persisted?

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Parameters:
        `saveSort` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getSaveSort

          public java.lang.Boolean getSaveSort()

      Should changes to which fields are sorted be persisted?

      Only valid with `SelectedAppearance` settings that allow direct interactivity (such as "outlineEdges").

      Returns:
        Boolean

    - #### getInlineEditText

          public void getInlineEditText()

      Returns the text based on the current component state to be edited inline. Called by the `EditProxy.inlineEditForm` to obtain the starting edit value.

      Returns the grid's wiki-style data - see `MockDataSource.mockData` for a description of this format.

      Overrides:
        `getInlineEditText` in class `EditProxy`

    - #### setInlineEditText

          public void setInlineEditText(java.lang.String newValue)

      Save the new value into the component's state. Called by the `EditProxy.inlineEditForm` to commit the change.

      Updates the grid's data and field configuration.

      Overrides:
        `setInlineEditText` in class `EditProxy`
      Parameters:
        `newValue` - the new grid configuration